FatMouse and Cheese(HDU 1078) —— 记忆化搜索DP

FatMouse and Cheese

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 4884    Accepted Submission(s): 1987


Problem Description
FatMouse has stored some cheese in a city. The city can be considered as a square grid of dimension n: each grid location is labelled (p,q) where 0 <= p < n and 0 <= q < n. At each grid location Fatmouse has hid between 0 and 100 blocks of cheese in a hole. Now he's going to enjoy his favorite food.

FatMouse begins by standing at location (0,0). He eats up the cheese where he stands and then runs either horizontally or vertically to another location. The problem is that there is a super Cat named Top Killer sitting near his hole, so each time he can run at most k locations to get into the hole before being caught by Top Killer. What is worse -- after eating up the cheese at one location, FatMouse gets fatter. So in order to gain enough energy for his next run, he has to run to a location which have more blocks of cheese than those that were at the current hole.

Given n, k, and the number of blocks of cheese at each grid location, compute the maximum amount of cheese FatMouse can eat before being unable to move.

Input
There are several test cases. Each test case consists of

a line containing two integers between 1 and 100: n and k
n lines, each with n numbers: the first line contains the number of blocks of cheese at locations (0,0) (0,1) ... (0,n-1); the next line contains the number of blocks of cheese at locations (1,0), (1,1), ... (1,n-1), and so on.
The input ends with a pair of -1's.

Output
For each test case output in a line the single integer giving the number of blocks of cheese collected.

Sample Input
   
   
   
   
3 1 1 2 5 10 11 6 12 12 7 -1 -1

Sample Output
   
   
   
   
37

Source
Zhejiang University Training Contest 2001

 

题意:给你n*n的格子,每个格子里一个数字,一开始你在(0,0)位置,你可以沿直线走k个格子,但下一个格子里的数字一定比当前格子里的数字大,问最大累加能得到多大。

 

又是一个典型的记忆化搜索,由于我写的搜索题目太少,导致写了半天。转移方程:dp[i][j] = max(dp[i][j], a[i][j]+dp[u][v])。

#include<cstdio>
#include<cstring>
#include<algorithm>
using namespace std;
int k, a[210][210], dp[210][210]; //dp代表(i,j)点能达到的最大值
//由于我不考虑格子边界,故下标从1开始,数组开大了些。
int dfs(int i, int j)
{
    int u, num = 0;
    if(dp[i][j] != 0) return dp[i][j]; //如果算过,则直接返回
    for(u=1; u<=k; u++)
    {
        if(a[i][j] < a[i-u][j]) dp[i][j] = max(dp[i][j], a[i][j]+dfs(i-u,j));
        if(a[i][j] < a[i+u][j]) dp[i][j] = max(dp[i][j], a[i][j]+dfs(i+u,j));
        if(a[i][j] < a[i][j-u]) dp[i][j] = max(dp[i][j], a[i][j]+dfs(i,j-u));
        if(a[i][j] < a[i][j+u]) dp[i][j] = max(dp[i][j], a[i][j]+dfs(i,j+u));
    }
    return dp[i][j] = max(dp[i][j], a[i][j]);
}

int main()
{
    int n, i, j, r;

    while(~scanf("%d%d", &n,&k))
    {
        if(n == -1 && k == -1) break;
        memset(a, 0, sizeof(a));
        memset(dp, 0, sizeof(dp));
        for(i=1; i<=n; i++)
            for(j=1; j<=n; j++)
                scanf("%d", &a[i][j]);
        printf("%d\n", dfs(1,1));
    }
    return 0;
}


 

你可能感兴趣的:(动态规划,记忆化搜索,ACMICPC)